; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 656
WINDOWHEIGHT = 518
GL_FOG_COORDINATE_SOURCE_EXT	equ 8450h; Value Taken From GLEXT.H
GL_FOG_COORDINATE_EXT		equ 8451h; Value Taken From GLEXT.H
BITMAPFILEHEADER STRUCT
  bfType        dw ?
  bfSize        dd ?
  bfReserved1   dw ?
  bfReserved2   dw ?
  bfOffBits     dd ?
BITMAPFILEHEADER ENDS
BITMAPINFOHEADER STRUCT
  biSize          dd ?
  biWidth         dd ?
  biHeight        dd ?
  biPlanes        dw ?
  biBitCount      dw ?
  biCompression   dd ?
  biSizeImage     dd ?
  biXPelsPerMeter dd ?
  biYPelsPerMeter dd ?
  biClrUsed       dd ?
  biClrImportant  dd ?
BITMAPINFOHEADER ENDS
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	w:dword
local	h:dword

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN          
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY:invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
	invoke	RtlExitUserProcess,NULL
;------------------------------
wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	cmp	al,VK_UP
	jne	@f
	movss	xmm0,camz
	comiss	xmm0,const14
	ja	wmBYE
	addss	xmm0,const0_25
	jmp	@0
@@:	cmp	al,VK_DOWN
	jne	wmBYE
	movss	xmm0,camz
	comiss	xmm0,const_19
	jbe	wmBYE
	subss	xmm0,const0_25
@0:	movss	camz,xmm0
	invoke	InvalidateRect,,0,0
        jmp	wmBYE
;-----------------------------------------	
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
;-------------------------------------------------------
; Start Of User Initialization
	invoke	Extension_Init; Check And Enable Fog Extension If Available
	or	eax,eax
	jz      wmBYE; Return False If Extension Not Supported
	invoke	BuildTexture; Load The Wall Texture

	invoke	glEnable,GL_TEXTURE_2D; Enable Texture Mapping
	movss	xmm3,const0_5
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor; (0.0f, 0.0f, 0.0f, 0.5f; Black Background
	movsd	xmm0,constd1
	invoke	glClearDepth; (1.0f; Depth Buffer Setup
	invoke	glDepthFunc,GL_LEQUAL; The Type Of Depth Testing
	invoke	glEnable,GL_DEPTH_TEST; Enable Depth Testing
	invoke	glShadeModel,GL_SMOOTH; Select Smooth Shading
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST; Set Perspective Calculations To Most Accurate
; Set Up Fog 
	invoke	glEnable,GL_FOG; Enable Fog
	invoke	glFogi,GL_FOG_MODE, GL_LINEAR; Fog Fade Is Linear
	mov	edx,offset fogColor
	invoke	glFogfv,GL_FOG_COLOR; Set The Fog Color
	xorps	xmm1,xmm1
	invoke	glFogf,GL_FOG_START;,0 Set The Fog Start
	movss	xmm1,const1
	invoke	glFogf,GL_FOG_END;,1; Set The Fog End
	invoke	glHint,GL_FOG_HINT, GL_NICEST; Per-Pixel Fog Calculation
	invoke	glFogi,GL_FOG_COORDINATE_SOURCE_EXT, GL_FOG_COORDINATE_EXT; Set Fog Based On Vertice Coordinates

	movr	camz,-19.0; Set Camera Z Position To -19.0f
        mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
	movq	xmm3,constd100
	movq	xmm2,constd0_1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
; --------------- Display the scene
	invoke  glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT; Clear Screen And Depth Buffer
	invoke  glLoadIdentity; Reset The Modelview Matrix
	movss	xmm2,camz
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef;,0, 0, camz; Move To Our Camera Z Position
	
	invoke	glBegin,GL_QUADS; Back Wall
	movss	xmm0,const1
	invoke	glFogCoordfEXT;( 1.0f;
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 0.0f;
	movss	xmm2,const_15
	movss	xmm1,const_2_5
	movss	xmm0,xmm1
	invoke	glVertex3f;(-2.5f,-2.5f,-15.0f;
	movss	xmm0,const1
	invoke	glFogCoordfEXT;( 1.0f;
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTexCoord2f;(1.0f, 0.0f;
	movss	xmm2,const_15
	movss	xmm1,const_2_5
	movss	xmm0,const2_5
	invoke	glVertex3f;( 2.5f,-2.5f,-15.0f;
	movss	xmm0,const1
	invoke	glFogCoordfEXT;( 1.0f;
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;(1.0f, 1.0f;
	movss	xmm2,const_15
	movss	xmm1,const2_5
	movss	xmm0,xmm1
	invoke	glVertex3f;( 2.5f, 2.5f,-15.0f;
	movss	xmm0,const1
	invoke	glFogCoordfEXT;( 1.0f;
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 1.0f;
	movss	xmm2,const_15
	movss	xmm1,const2_5
	movss	xmm0,const_2_5
	invoke	glVertex3f;(-2.5f, 2.5f,-15.0f;
	invoke	glEnd;

	invoke	glBegin,GL_QUADS; Floor
	movss	xmm0,const1
	invoke	glFogCoordfEXT;( 1.0f;	
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 0.0f;	
	movss	xmm2,const_15
	movss	xmm1,const_2_5
	movss	xmm0,xmm1
	invoke	glVertex3f;(-2.5f,-2.5f,-15.0f;
	movss	xmm0,const1
	invoke	glFogCoordfEXT;( 1.0f;	
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTexCoord2f;(1.0f, 0.0f;	
	movss	xmm2,const_15
	movss	xmm1,const_2_5
	movss	xmm0,const2_5
	invoke	glVertex3f;( 2.5f,-2.5f,-15.0f;
	xorps	xmm0,xmm0
	invoke	glFogCoordfEXT;( 0.0f;	
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;(1.0f, 1.0f;	
	movss	xmm2,const15
	movss	xmm1,const_2_5
	movss	xmm0,const2_5
	invoke	glVertex3f;( 2.5f,-2.5f, 15.0f;
	xorps	xmm0,xmm0
	invoke	glFogCoordfEXT;( 0.0f;	
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 1.0f;	
	movss	xmm2,const15
	movss	xmm1,const_2_5
	movss	xmm0,xmm1
	invoke	glVertex3f;(-2.5f,-2.5f, 15.0f;
	invoke	glEnd;

	invoke	glBegin,GL_QUADS; Roof
	movss	xmm0,const1
	invoke	glFogCoordfEXT;( 1.0f;	
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 0.0f;	
	movss	xmm2,const_15
	movss	xmm1,const2_5
	movss	xmm0,const_2_5
	invoke	glVertex3f;(-2.5f, 2.5f,-15.0f;
	movss	xmm0,const1
	invoke	glFogCoordfEXT;( 1.0f;	
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTexCoord2f;(1.0f, 0.0f;	
	movss	xmm2,const_15
	movss	xmm1,const2_5
	movss	xmm0,xmm1
	invoke	glVertex3f;( 2.5f, 2.5f,-15.0f;
	xorps	xmm0,xmm0
	invoke	glFogCoordfEXT;( 0.0f;	
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;(1.0f, 1.0f;	
	movss	xmm2,const15
	movss	xmm1,const2_5
	movss	xmm0,xmm1
	invoke	glVertex3f;( 2.5f, 2.5f, 15.0f;
	xorps	xmm0,xmm0
	invoke	glFogCoordfEXT;( 0.0f;	
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 1.0f;	
	movss	xmm2,const15
	movss	xmm1,const2_5
	movss	xmm0,const_2_5
	invoke	glVertex3f;(-2.5f, 2.5f, 15.0f;
	invoke	glEnd;

	invoke	glBegin,GL_QUADS; Right Wall
	xorps	xmm0,xmm0
	invoke	glFogCoordfEXT;( 0.0f;	
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 0.0f;	
	movss	xmm2,const15
	movss	xmm1,const_2_5
	movss	xmm0,const2_5
	invoke	glVertex3f;( 2.5f,-2.5f, 15.0f;
	xorps	xmm0,xmm0
	invoke	glFogCoordfEXT;( 0.0f;	
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 1.0f;	
	movss	xmm2,const15
	movss	xmm1,const2_5
	movss	xmm0,xmm1
	invoke	glVertex3f;( 2.5f, 2.5f, 15.0f;
	movss	xmm0,const1
	invoke	glFogCoordfEXT;( 1.0f;	
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;(1.0f, 1.0f;	
	movss	xmm2,const_15
	movss	xmm1,const2_5
	movss	xmm0,xmm1
	invoke	glVertex3f;( 2.5f, 2.5f,-15.0f;
	movss	xmm0,const1
	invoke	glFogCoordfEXT;( 1.0f;	
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTexCoord2f;(1.0f, 0.0f;	
	movss	xmm2,const_15
	movss	xmm1,const_2_5
	movss	xmm0,const2_5
	invoke	glVertex3f;( 2.5f,-2.5f,-15.0f;
	invoke	glEnd;

	invoke	glBegin,GL_QUADS; Left Wall
	xorps	xmm0,xmm0
	invoke	glFogCoordfEXT;( 0.0f;	
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 0.0f;	
	movss	xmm2,const15
	movss	xmm1,const_2_5
	movss	xmm0,xmm1
	invoke	glVertex3f;(-2.5f,-2.5f, 15.0f;
	xorps	xmm0,xmm0
	invoke	glFogCoordfEXT;( 0.0f;	
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;(0.0f, 1.0f;	
	movss	xmm2,const15
	movss	xmm1,const2_5
	movss	xmm0,const_2_5
	invoke	glVertex3f;(-2.5f, 2.5f, 15.0f;
	movss	xmm0,const1
	invoke	glFogCoordfEXT;( 1.0f;	
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;(1.0f, 1.0f;	
	movss	xmm2,const_15
	movss	xmm1,const2_5
	movss	xmm0,const_2_5
	invoke	glVertex3f;(-2.5f, 2.5f,-15.0f;
	movss	xmm0,const1
	invoke	glFogCoordfEXT;( 1.0f;	
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTexCoord2f;(1.0f, 0.0f;	
	movss	xmm2,const_15
	movss	xmm1,const_2_5
	movss	xmm0,xmm1
	invoke	glVertex3f;(-2.5f,-2.5f,-15.0f;
	invoke	glEnd 
	invoke	glFlush
;   
        invoke	SwapBuffers,hDC
wmBYE:	leave
	retn	
WndProc	endp
BuildTexture proc ;Load Image And Convert To A Texture
local	glMaxTexDim:dword ; Holds Maximum Texture Size
local	lHeightPixels:dword; Height In Pixels
local	lWidthPixels:dword; Width In Pixels
local	lHeight:dword; Height In Logical Units
local	lWidth:dword; Width In Logical Units
local	wszPath[MAX_PATH+1]:word; Full Path To Picture (WCHAR)
local	pPicture:qword;IPicture; IPicture Interface
local	hbmpTemp:HBITMAP; Holds The Bitmap Temporarily
local	hdcTemp:HDC; The DC To Hold Our Bitmap
local	hr:dword
local	pBits:dword
local	bi:BITMAPINFOHEADER

	lea	edx,wszPath
	invoke	GetCurrentDirectoryW,MAX_PATH; Get Our Working Directory
	lea	edi,wszPath
	mov	ecx,edi
	lea	edi,[rdi+rax*2]
	mov	esi,offset aWall_bmp
	movsq
	movsq
	movsd
	lea	eax,pPicture
	mov	[rsp+28h],rax
	movr	qword ptr [rsp+20h],IID_IPicture
	invoke	OleLoadPicturePath,,0,0,0
	mov	hr,eax
	or	eax,eax; If Loading Failed
	js	exit0;		return FALSE; Return False
	invoke	GetDC,0
	invoke	CreateCompatibleDC,eax; Create The Windows Compatible Device Context
	mov	hdcTemp,rax
	or	eax,eax
	jnz	@f; Did Creation Fail?
	mov	rcx,pPicture
	mov	eax,[rcx]
	call	qword ptr [rax+10h];pPicture->Release; Decrements IPicture Reference Count
	xor	eax,eax
	jmp	exit0; Return False (Failure)
@@:     lea	edx,glMaxTexDim
	invoke	glGetIntegerv,GL_MAX_TEXTURE_SIZE; Get Maximum Texture Size Supported
	lea	edx,lWidth
	mov	rcx,pPicture
	mov	eax,[rcx]
	call	qword ptr [rax+30h];pPicture->get_Width(&lWidth; Get IPicture Width (Convert To Pixels)
	invoke	GetDeviceCaps,hdcTemp, LOGPIXELSX
	mov	ecx,lWidth
	invoke	MulDiv,,eax,2540
	mov	lWidthPixels,eax
	lea	edx,lHeight
	mov	rcx,pPicture
	mov	eax,[rcx]
	call	qword ptr [rax+38h];pPicture->get_Height(&lHeight; Get IPicture Height (Convert To Pixels)
	invoke	GetDeviceCaps,hdcTemp, LOGPIXELSY
	invoke	MulDiv,lHeight,eax,2540;
	mov	lHeightPixels,eax
; Resize Image To Closest Power Of Two
        mov	eax, glMaxTexDim
	cmp	lWidthPixels,eax
	jg	@1;if (lWidthPixels <= glMaxTexDim) // Is Image Width Less Than Or Equal To Cards Limit
        cvtsi2sd xmm0,lWidthPixels
	call	log
	divsd	xmm0,constln2
	addsd	xmm0,constd0_5
	call	floor
	cvttsd2si ecx,xmm0
	mov	eax,1
	shl	eax,cl;lWidthPixels = 1 << (int)floor((log((double)lWidthPixels)/log(2.0))+0.5
	jmp	@f
;	else  // Otherwise  Set Width To "Max Power Of Two" That The Card Can Handle
@1:	mov	eax,glMaxTexDim;lWidthPixels = glMaxTexDim;
@@:	mov	lWidthPixels,eax 
	mov	eax,glMaxTexDim
	cmp	lHeightPixels,eax;if (lHeightPixels <= glMaxTexDim) // Is Image Height Greater Than Cards Limit
	jg	@2
        cvtsi2sd xmm0,lHeightPixels
	call	log
	divsd	xmm0,constln2
	addsd	xmm0,constd0_5
	call	floor
	cvttsd2si ecx,xmm0
	mov	eax,1
	shl	eax,cl;lHeightPixels = 1 << (int)floor((log((double)lHeightPixels)/log(2.0))+0.5;
	jmp	@f
;	else  // Otherwise  Set Height To "Max Power Of Two" That The Card Can Handle
@2:     mov	eax, glMaxTexDim;lHeightPixels = glMaxTexDim;
@@:	mov	lHeightPixels, eax	
;Create A Temporary Bitmap
	lea	edi,bi
	xor	eax,eax
	mov	ecx,(sizeof BITMAPINFOHEADER)/8;28h
	rep	stosq

	mov	bi.biSize,sizeof BITMAPINFOHEADER; Set Structure Size
	mov	bi.biBitCount,32; 32 Bit
	mov	eax,lWidthPixels
	mov	bi.biWidth,eax; Power Of Two Width
	mov	eax,lHeightPixels
	mov	bi.biHeight,eax; Make Image Top Up (Positive Y-Axis)
	mov	bi.biCompression,BI_RGB; RGB Encoding
	mov	bi.biPlanes,1; 1 Bitplane

;Creating A Bitmap This Way Allows Us To Specify Color Depth And Gives Us Imediate Access To The Bits
	lea	edx,bi
	lea	r9d,pBits
	xor	r8d,r8d;DIB_RGB_COLORS
	mov	[rsp+20h],r8
	mov	[rsp+28h],r8
	invoke	CreateDIBSection,hdcTemp;hbmpTemp = CreateDIBSection(hdcTemp, &bi, DIB_RGB_COLORS, (void**)&pBits, 0, 0;
	mov	hbmpTemp,rax
	or	eax,eax
	jnz	@f; Did Creation Fail?
	invoke	DeleteDC,hdcTemp; Delete The Device Context
	mov	rcx,pPicture
	mov	eax,[rcx]
	call	qword ptr [rax+10h];pPicture->Release; Decrements IPicture Reference Count
	xor	eax,eax
	jmp	exit0;return FALSE; Return False (Failure)
@@:	invoke	SelectObject,hdcTemp,eax;SelectObject(hdcTemp, hbmpTemp; Select Handle To Our Temp DC And Our Temp Bitmap Object
; Render The IPicture On To The Bitmap
	xor	r9d,r9d
	mov	[rsp+50h],r9
	mov	eax,lWidth
	mov	[rsp+40h],rax
	mov	eax,lHeight
	mov	[rsp+38h],rax
	neg	rax
	mov	[rsp+48h],rax
	mov	[rsp+30h],r9
	mov	eax,lHeightPixels
	mov	[rsp+28h],rax
	mov	eax,lWidthPixels
	mov	[rsp+20h],rax
	xor	r8d,r8d
        mov	rdx,hdcTemp
        mov	rcx,pPicture
	mov	eax,[rcx]
	call	qword ptr [rax+40h];pPicture->Render(hdcTemp, 0, 0, lWidthPixels, lHeightPixels, 0, lHeight, lWidth, -lHeight, 0;
	mov	edx,offset texture
	invoke	glGenTextures,1; Create The Texture
; Typical Texture Generation Using Data From The Bitmap
	mov	edx,offset texture
	mov	edx,[rdx]
	invoke	glBindTexture,GL_TEXTURE_2D; Bind To The Texture ID
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR;(Modify This For The Type Of Filtering You Want)
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR;(Modify This For The Type Of Filtering You Want)
	mov	eax,pBits
	mov	[rsp+40h],rax
	mov	qword ptr [rsp+38h],GL_UNSIGNED_BYTE
	mov	qword ptr [rsp+30h],GL_BGRA
	xor	edx,edx
	mov	[rsp+28h],rdx
	mov	eax,lHeightPixels
	mov	[rsp+20h],rax
	mov	r9d,lWidthPixels
	invoke	glTexImage2D,GL_TEXTURE_2D,,3
; (Modify This If You Want Mipmaps)
	invoke	DeleteObject,hbmpTemp; Delete The Object
	invoke	DeleteDC,hdcTemp; Delete The Device Context
        mov	rcx,pPicture
	mov	eax,[rcx]
        call	qword ptr [rax+10h];pPicture->Release; Decrements IPicture Reference Count
	mov	eax,TRUE;return TRUE; Return True (All Good)
exit0:	leave
	ret
BuildTexture endp
Extension_Init proc
local	glextstring:dword
; Allocate Memory For Our Extension String
;	char* glextstring=(char *)malloc(strlen((char *)glGetString(GL_EXTENSIONS))+1;
	invoke	glGetString,GL_EXTENSIONS
	invoke	strlen,eax
	lea	edx,[rax+1]
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED
	mov	glextstring,eax
	invoke	glGetString,GL_EXTENSIONS
	mov	ecx,glextstring
	invoke	strcpy,,eax
;	strcpy (glextstring,(char *)glGetString(GL_EXTENSIONS); Grab The Extension List, Store In glextstring
	mov	edx,offset aExt_fog_coord ; "EXT_fog_coord"
	mov	ecx,glextstring
	invoke	strstr
;	if (!strstr(glextstring,Extension_Name))// Check To See If The Extension Is Supported
	or	eax,eax; If Not, Return FALSE
	jz	exit0
	mov	ecx,glextstring
	invoke	GlobalFree;free(glextstring; Free Allocated Memory
; Setup And Enable glFogCoordEXT
	mov	ecx,offset aGlfogcoordfext ; "glFogCoordfEXT"
	invoke	wglGetProcAddress
	mov	glFogCoordfEXT,rax;glFogCoordfEXT = (PFNGLFOGCOORDFEXTPROC) wglGetProcAddress("glFogCoordfEXT";
exit0:	leave
	ret
Extension_Init endp
;---------------------------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson#41: Volumetric Fog Tutorial",0
FileName	db "br_Rabbit3.cur",0
aWall_bmp:	du <\wall.bmp>;Name of Picture (WCHAR)
aExt_fog_coord  db "EXT_fog_coord",0
aGlfogcoordfext db "glFogCoordfEXT",0
fogColor	dd 0.6, 0.3, 0, 1.0; Fog Colour 
camz		dd ?
texture		dd ?
glFogCoordfEXT	dq ?
IID_IPicture	dd 7BF80980h,101ABF32h,0AA00BB8Bh,0AB0C3000h
;-----------------------------
;float
const0_25	dd 0.25
const0_5 	dd 0.5
const1		dd 1.0
const2_5	dd 2.5
const_2_5	dd -2.5
const14		dd 14.0
const15		dd 15.0
const_15	dd -15.0
const_19	dd -19.0
;double
constd0_1	dq 0.1
constd0_5	dq 0.5
constd1		dq 1.0
constln2       	dq 0.69314718055994530941723212146
constd45	dq 45.0
constd100	dq 100.0
end